/*
	Ejercicio:	2x4x03
	Fecha:		09/10/2012

	Enunciado:
		a) Realiza un programa Java que cree un fichero binario para guardar datos (objetos) de departamentos (departamentos.dat). Los datos para cada departamento son:
			- Numdepartamento: entero
			- Nombre: String
			- Localidad: String

		Introduce varios departamentos
			
		b) A partir del fichero departamentos.dat anterior, crea un fichero XML usando la librera XStream.
		c) Crea una plantilla XSL para dar una presentacin al fichero XML generado en el apartado b) y realiza un programa Java para transformarlo en HTML.
		
*/


import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.ObjectInputStream;
import java.io.ObjectOutputStream;
import java.util.Vector;

import javax.xml.transform.Result;
import javax.xml.transform.Source;
import javax.xml.transform.Transformer;
import javax.xml.transform.TransformerFactory;
import javax.xml.transform.stream.StreamResult;
import javax.xml.transform.stream.StreamSource;

import com.thoughtworks.xstream.XStream;


public class _2x4x03
{

	// a) Realiza un programa Java que cree un fichero binario para guardar datos (objetos) de departamentos (departamentos.dat).
	private static void creaDatosDepartamentos(String[] args) throws IOException
	{
		ObjectOutputStream oos = new ObjectOutputStream(new FileOutputStream(new File(args[0]), false));

		oos.writeObject(new Departamento(1, "Administracion", "Huesca"));
		oos.writeObject(new Departamento(2, "Marketing", "Zaragoza"));
		oos.writeObject(new Departamento(2, "Ventas", "Teruel"));

		oos.close();
	}


	// b) A partir del fichero departamentos.dat anterior, crea un fichero XML usando la librera XStream.
	public static void datToXMLWithXStream(String[] args) throws IOException, ClassNotFoundException
	{
		FileInputStream fis = new FileInputStream(new File(args[0]));
		ObjectInputStream ois = new ObjectInputStream(fis);

		Vector<Departamento> listaDepartamentos = new Vector<Departamento>();


		while( fis.available() > 0 )
			listaDepartamentos.add((Departamento)ois.readObject());

		ois.close();
		fis.close();

		try
		{
			XStream xstream = new XStream();
			xstream.alias("departamentos", Vector.class);
			xstream.alias("departamento", Departamento.class);
			xstream.toXML(listaDepartamentos, new FileOutputStream(new File(args[1])));
		}
		catch( Exception e )
		{
			e.printStackTrace();
		}

	}


	// c) Crea una plantilla XSL para dar una presentacin al fichero XML generado en el apartado b) y realiza un programa Java para transformarlo en HTML.
	public static void XMLAndXSLToHTML(String[] args) throws FileNotFoundException
	{
		Source sXML = new StreamSource(new File(args[1])); //XML
		Source sXSL = new StreamSource(new File(args[2])); // XSL
		Result rHTML = new StreamResult(new FileOutputStream(new File(args[3]))); //HTML

		try
		{
			Transformer transformer = TransformerFactory.newInstance().newTransformer(sXSL);
			transformer.transform(sXML, rHTML);
		}
		catch( Exception e )
		{
			e.printStackTrace();
		}

	}


	public static void main(String[] args) throws IOException, ClassNotFoundException
	{

		String[] argumentos = { "departamentos.dat", "departamentos.xml", "departamentos.xsl", "departamentos.html" };

		//A:
		creaDatosDepartamentos(argumentos);

		//B:
		datToXMLWithXStream(argumentos);

		//C:
		XMLAndXSLToHTML(argumentos);

	}
}
