/*
	Ejercicio:	2x4x04
	Fecha:		09/10/2012

	Enunciado:
		Hacer el ejercicio 1 usando XStreme
*/

import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.ObjectInputStream;
import java.io.ObjectOutputStream;
import java.util.Iterator;
import java.util.Vector;

import org.w3c.dom.Document;
import org.w3c.dom.Element;

import org.w3c.dom.Text;

import com.thoughtworks.xstream.XStream;


public class _2x4x04
{
	// a) Crea un fichero "FichPersona.dat",  que almacene varios objetos persona.
	private static void creaFicheroDatosPersonas(String[] args) throws IOException
	{
		ObjectOutputStream oos = new ObjectOutputStream(new FileOutputStream(new File(args[0]), false));

		oos.writeObject(new Persona("Pedro", 53));
		oos.writeObject(new Persona("Juan", 26));
		oos.writeObject(new Persona("Maria", 32));
		oos.writeObject(new Persona("Laura", 19));

		oos.close();
	}


	// b) Tomando como base el fichero anterior, crea un documento XML usando XStreme.
	private static void creaFicheroXMLPersonas(String[] args) throws IOException, ClassNotFoundException
	{
		FileInputStream fis = new FileInputStream(new File(args[0]));
		ObjectInputStream ois = new ObjectInputStream(fis);


		Vector<Persona> listaDepartamentos = new Vector<Persona>();


		while( fis.available() > 0 )
			listaDepartamentos.add((Persona)ois.readObject());

		ois.close();
		fis.close();

		try
		{
			XStream xstream = new XStream();
			xstream.alias("personas", Vector.class);
			xstream.alias("persona", Persona.class);
			xstream.toXML(listaDepartamentos, new FileOutputStream(new File(args[1])));
		}
		catch( Exception e )
		{
			e.printStackTrace();
		}
	}


	static void crearElemento(String datoEmple, String valor, Element raiz, Document document)
	{
		Element elem = document.createElement(datoEmple);
		Text text = document.createTextNode(valor);
		raiz.appendChild(elem);
		elem.appendChild(text);
	}


	// c) Implementa una clase que permita leer el documento XML del apartado anterior.
	public static void imprimirFicheroXMLPersonas(String[] args)
	{
		XStream xstream = new XStream();
		xstream.alias("personas", Vector.class);
		xstream.alias("persona", Persona.class);

		Vector<Persona> listaPersonas = (Vector<Persona>)xstream.fromXML(new File(args[1]));
		System.out.println("Numero de personas: " + listaPersonas.size());

		Iterator<Persona> iterator = listaPersonas.listIterator();

		while( iterator.hasNext() )
			System.out.println(( (Persona)iterator.next() ).toString());

	}


	public static void main(String[] args) throws IOException, ClassNotFoundException
	{
		String[] argumentos = { "personas.dat", "personas.xml" };
		creaFicheroDatosPersonas(argumentos);
		creaFicheroXMLPersonas(argumentos);
		imprimirFicheroXMLPersonas(argumentos);
	}
}
